(document:surround "/std/frame")

(define (write-mode)
  (catch/message
    (lambda()
      (apply woo-write
	     "/control/facility"
	     (form-value-list)))))

(define (update-help fname name)
  (form-update-value-list '("help")
			  (woo-read-first "/control/facility"
					  'name name
					  'fname fname)))

(define (update-facility fname)
  (let* ((name (woo-get-option
		 (woo-read-first "/control/facility" 'fname fname)
		 'name))
	 (mode-list (woo-list "/control/facility" 'fname fname)))
    (form-update-enum "name" mode-list)
    (form-update-value "name" name)
    (update-help fname name)))

(gridbox
  margin 20
  columns "20;80"

  ;;
  (listbox colspan 2
	   columns 2
	   name "fname"
	   row '#((name . "") (summary . ""))
	   header (vector (_ "Facility") (_ "Summary")))

  ;;
  (label colspan 2)

  ;;
  (separator colspan 2)

  ;;
  (label text (bold (_ "State")) colspan 2)

  ;;
  (listbox name "name")
  (textbox name "help")

  ;;
  (spacer)
  (button text (_ "Apply") align "right" name "apply"))

(document:root (when loaded
		 (catch/message
		   (lambda()
		     (let ((facility-list (woo-list "/control")))
		       (form-bind "fname" "change" (lambda() (update-facility (form-value "fname"))))
		       (form-bind "name" "change" (lambda() (update-help (form-value "fname") (form-value "name"))))
		       (form-bind "apply" "click" write-mode)
		       (form-update-enum "fname" facility-list)
		       (or (null? facility-list)
			   (let ((fname (woo-get-option (car facility-list) 'name)))
			     (form-update-value "fname" fname)
			     (update-facility fname))))))))

